import { IResolvers } from 'graphql-tools';
export declare type ResolversCompositionFn<TResolver> = (next: TResolver) => TResolver;
export declare type IResolversComposerMapping<TResolvers = IResolvers> = {
    [TypeName in keyof TResolvers]: TypeName extends string ? ResolversCompositionFn<TResolvers[TypeName]> | ResolversCompositionFn<TResolvers[TypeName]>[] | {
        [FieldName in keyof TResolvers[TypeName]]: FieldName extends string ? ResolversCompositionFn<TResolvers[TypeName]> | ResolversCompositionFn<TResolvers[TypeName]>[] : never;
    } : never;
};
/**
 * Wraps the resolvers object with the resolvers composition objects.
 * Implemented as a simple and basic middleware mechanism.
 *
 * @param resolvers - resolvers object
 * @param mapping - resolvers composition mapping
 * @hidden
 */
export declare function composeResolvers<TSource, TContext>(resolvers: IResolvers<TSource, TContext>, mapping?: IResolversComposerMapping): IResolvers;
